<%@ page language="cs" runat="server"%>
<%@ Import Namespace="System.Data" %>
<script runat="server">
DataTable Employees;
DataView EmployeesView;
void Page_Load(Object sender, EventArgs e){
	if (Session["Employees"] == null){
   	Employees = new DataTable();
      Employees.Columns.Add(new DataColumn("ID", typeof(string)));
      Employees.Columns.Add(new DataColumn("FirstName", typeof(string)));
      Employees.Columns.Add(new DataColumn("LastName", typeof(string)));
      Session["Employees"] = Employees;
         
      String[,] OurArray = {{"1","Nancy","Davolio"},{"54","Andrew","Fuller"}
		,{"138","Janet","Leverling"}};
			         
      for (int i = 0;i<=2;i++){
      	DataRow dr = Employees.NewRow();
         dr[0] = OurArray[i,0];
         dr[1] = OurArray[i,1];
         dr[2] = OurArray[i,2];
         Employees.Rows.Add(dr);
      }
	}else{
   	Employees = (DataTable)Session["Employees"];
   }
   EmployeesView = new DataView(Employees);
   EmployeesView.Sort = "ID";
   if (!IsPostBack){
   	BindList();
   }
}
     
void BindList(){
	OurDataList.DataSource = EmployeesView;
   OurDataList.DataBind();
} 

void DataList_EditCommand(Object sender,DataListCommandEventArgs e){
	OurDataList.EditItemIndex = (int)e.Item.ItemIndex;
   BindList();
}

void DataList_CancelCommand(Object sender,DataListCommandEventArgs e){
	OurDataList.EditItemIndex = - 1;
   BindList();
}

void DataList_DeleteCommand(Object sender,DataListCommandEventArgs e){
	String ID = ((Label) e.Item.FindControl("OurLabel")).Text;
	EmployeesView.RowFilter = "ID='" + ID + "'";
   if (EmployeesView.Count > 0){
   	EmployeesView.Delete(0);
   }
   EmployeesView.RowFilter = "";
	OurDataList.EditItemIndex = - 1;
        BindList();
}

void DataList_UpdateCommand(Object sender,DataListCommandEventArgs e){
	String ID = ((Label)e.Item.FindControl("OurLabel")).Text;
   String FirstName = ((TextBox)e.Item.FindControl("FirstNameText")).Text;
   String LastName = ((TextBox)e.Item.FindControl("LastNameText")).Text;
	EmployeesView.RowFilter = "ID='" + ID + "'";
	if (EmployeesView.Count > 0){ 
		EmployeesView.Delete(0);
	} 
   EmployeesView.RowFilter = "";        
	DataRow dr = Employees.NewRow();
   dr[0] = ID;
   dr[1] = FirstName;
   dr[2] = LastName;
   Employees.Rows.Add(dr);
	OurDataList.EditItemIndex = - 1;
	BindList();
}

</script>
<html>
<head>
<title>Edit DataList</title>
</head>
<body>
<form runat=server>
<asp:DataList id="OurDataList" runat="server"
	BorderWidth="1"
	BorderColor="#000000"
   CellPadding="3"
   CellSpacing="1"
   Font-Name="Verdana"
   Font-Size="12px"
   HeaderStyle-BackColor="#AAAAAA"
   ItemStyle-BackColor="#EEEEEE"
   EditItemStyle-BackColor="#CCCCCC"
   OnEditCommand="DataList_EditCommand"
   OnUpdateCommand="DataList_UpdateCommand"
   OnDeleteCommand="DataList_DeleteCommand"
   OnCancelCommand="DataList_CancelCommand">
<HeaderTemplate><b>Employees</b></HeaderTemplate>
<ItemTemplate>
	<u>ID:</u> 
	<%# ((DataRowView)Container.DataItem)["ID"]%><br>
	<u>Name:</u> 
	<%# ((DataRowView)Container.DataItem)["FirstName"]%>
	<%# ((DataRowView)Container.DataItem)["LastName"]%><br>
	<asp:LinkButton 
		id="button1" 
		Text="Edit" 
		CommandName="edit"
      runat="server"/>
</ItemTemplate>
<EditItemTemplate>
ID:
<asp:Label id="OurLabel" 
	Text='<%# ((DataRowView)Container.DataItem)["ID"]%>' 
	runat="server"/><br>
FirstName:
<asp:TextBox id="FirstNameText" 
	Text='<%# ((DataRowView)Container.DataItem)["FirstName"]%>'
	Size="5"
	runat="server"/><br>
LastName:
<asp:TextBox id="LastNameText" 
	Text='<%# ((DataRowView)Container.DataItem)["LastName"]%>'
	Size="5" 
	runat="server"/> <br>
<asp:LinkButton id="button2" 
	Text="Update" 
	CommandName="update" 
	runat="server"/>
<asp:LinkButton id="button3" 
	Text="Delete" 
	CommandName="delete" 
	runat="server"/>
<asp:LinkButton id="button4" 
	Text="Cancel" 
	CommandName="cancel" 
	runat="server"/>
</EditItemTemplate>
</asp:DataList>
</form>
</body>
</html>
