<%@ page language="vb" runat="server"%>
<%@ Import Namespace="System.Data" %>
<script language="VB" runat="server">
Dim Employees As DataTable
Dim EmployeesView As DataView

Sub Page_Load(sender As Object, e As EventArgs)
	If Session("Employees") Is Nothing Then
   	Employees = New DataTable()
      Employees.Columns.Add(New DataColumn("ID", GetType(String)))
      Employees.Columns.Add(New DataColumn("FirstName", GetType(String)))
      Employees.Columns.Add(New DataColumn("LastName", GetType(String)))
      Session("Employees") = Employees
         
      dim OurArray(,) as String = {{"1","Nancy","Davolio"},{"54","Andrew","Fuller"},{"138","Janet","Leverling"}}
			    
      dim i As Integer
      For i = 0 To 2
      	Dim dr As DataRow = Employees.NewRow()
         dr(0) = OurArray(i,0)
         dr(1) = OurArray(i,1)
         dr(2) = OurArray(i,2)
         Employees.Rows.Add(dr)
      Next i
	Else
   	Employees = CType(Session("Employees"), DataTable)
      End If 
      EmployeesView = New DataView(Employees)
      EmployeesView.Sort = "ID"
      If Not IsPostBack Then
      	BindList()
      End If
End Sub
     
Sub BindList()
	OurDataList.DataSource = EmployeesView
   OurDataList.DataBind()
End Sub 

Sub DataList_EditCommand(sender As Object, e As DataListCommandEventArgs)
	OurDataList.EditItemIndex = CInt(e.Item.ItemIndex)
   BindList()
End Sub 

Sub DataList_CancelCommand(sender As Object, e As DataListCommandEventArgs)
	OurDataList.EditItemIndex = - 1
	BindList()
End Sub 

Sub DataList_DeleteCommand(sender As Object, e As DataListCommandEventArgs)
	Dim ID As String = CType(e.Item.FindControl("OurLabel"), Label).Text
	EmployeesView.RowFilter = "ID='" & ID & "'"
	If EmployeesView.Count > 0 Then 
		EmployeesView.Delete(0)
	End If 
	EmployeesView.RowFilter = ""
	OurDataList.EditItemIndex = - 1
	BindList()
End Sub 

Sub DataList_UpdateCommand(sender As Object, e As DataListCommandEventArgs)
	Dim ID As String = CType(e.Item.FindControl("OurLabel"), Label).Text
	Dim FirstName As String = CType(e.Item.FindControl("FirstNameText"), TextBox).Text
	Dim LastName As String = CType(e.Item.FindControl("LastNameText"), TextBox).Text
	EmployeesView.RowFilter = "ID='" & ID & "'"
	If EmployeesView.Count > 0 Then
		EmployeesView.Delete(0)
	End If 
	EmployeesView.RowFilter = ""        
	Dim dr As DataRow = Employees.NewRow()
	dr(0) = ID
	dr(1) = FirstName
	dr(2) = LastName
	Employees.Rows.Add(dr)
	OurDataList.EditItemIndex = - 1
	BindList()
End Sub 
</script>
<html>
<head>
<title>Edit DataList</title>
</head>
<body>
<form runat=server>
<asp:DataList id="OurDataList" runat="server"
	BorderWidth="1"
	BorderColor="#000000"
   CellPadding="3"
   CellSpacing="1"
   HeaderStyle-BackColor="#AAAAAA"
   ItemStyle-BackColor="#EEEEEE"
   EditItemStyle-BackColor="#CCCCCC"
   OnEditCommand="DataList_EditCommand"
   OnUpdateCommand="DataList_UpdateCommand"
   OnDeleteCommand="DataList_DeleteCommand"
   OnCancelCommand="DataList_CancelCommand">
<HeaderTemplate><b>Employees</b></HeaderTemplate>
<ItemTemplate>
	<u>ID:</u> 
	<%# (CType(Container.DataItem, DataRowView))("ID")%><br>
	<u>Name:</u> 
	<%# (CType(Container.DataItem, DataRowView))("FirstName")%>
	<%# (CType(Container.DataItem, DataRowView))("LastName")%><br>
	<asp:LinkButton 
		id="button1" 
		Text="Edit" 
		CommandName="edit"
      runat="server"/>
</ItemTemplate>
<EditItemTemplate>
ID:
<asp:Label id="OurLabel" 
	Text='<%# (CType(Container.DataItem, DataRowView))("ID") %>' 
	runat="server"/><br>
FirstName:
<asp:TextBox id="FirstNameText" 
	Text='<%# (CType(Container.DataItem, DataRowView))("FirstName") %>' 
	runat="server"/><br>
LastName:
<asp:TextBox id="LastNameText" 
	Text='<%# DataBinder.Eval(Container.DataItem, "LastName") %>' 
	runat="server"/> <br>
<asp:LinkButton id="button2" 
	Text="Update" 
	CommandName="update" 
	runat="server"/>
<asp:LinkButton id="button3" 
	Text="Delete" 
	CommandName="delete" 
	runat="server"/>
<asp:LinkButton id="button4" 
	Text="Cancel" 
	CommandName="cancel" 
	runat="server"/>
</EditItemTemplate>
</asp:DataList>
</form>
</body>
</html>
